<template>
    <aside aria-label="Sidebar">
        <v-layout>
            <v-navigation-drawer
                v-model="sidebarMenu"
                app
                :floating="true"
                :permanent="true"
                :rail="sidebarCollapsed"
                class="!bg-[#F7F8FB] flex !flex-wrap transition ease-out !h-screen pt-6 border-1 bg-grey-lighten-5"
            >
                <div class="flex flex-col h-full justify-between" id="sidebar-menu">
                    <div class="px-0">
                        <v-list class="flex !p-0 justify-center">
                            <LogoImage></LogoImage>
                            <div class="logo-container d-flex align-center justify-center">
                              <pretty-link>
                                <template #title>
                                  Admin Admin
                                </template>
                              </pretty-link>
                            </div>
                        </v-list>

                        <v-list class="space-y-4" density="compact" v-if="items">

                          <NavigationItem
                            v-for="item in filteredItems"
                            :item="item"
                            :key="item.title"
                          />

                        </v-list>
                    </div>
                    <div class="border-t pt-3">
                        <navigation-card />
                    </div>
                </div>
            </v-navigation-drawer>
        </v-layout>
    </aside>
</template>

<script lang="ts" setup>
import { ref } from 'vue';
import { menuItems } from './menu-items';
import { GeneralGuard } from '@/guards/GeneralGuard';
import { useRoute } from 'vue-router';
import NavigationCard from './NavigationCard.vue';
import { computed } from 'vue';
import Logo from '../LogoImage.vue';
import NavigationItem from '@/components/navigation/NavigationItem.vue'
import PrettyLink from '@/components/link/PrettyLink.vue'
import LogoImage from '@/components/LogoImage.vue'

const items = ref(menuItems());
const route = useRoute();

const sidebarMenu = ref(true);
const sidebarCollapsed = ref(false);
const toggleMini = ref(false);

// const toggleSidebar = () => {
//     toggleMini.value = !toggleMini.value;
// };

const filteredItems = computed(() => {
    return items.value.filter((item) => item && isPageAllowed(item.to));
});

const isActivePage = (page: any) => {
    return route.name === page.name;
};
const isPageAllowed = (targetPage: any) => {
    const guard = new GeneralGuard();
    return guard.canEnterMenuItem(targetPage);
};
</script>
